import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueReceiver;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.jms.Session;
import javax.jms.TextMessage;

import org.apache.activemq.ActiveMQConnectionFactory;

public class P1 {
    private static final String SERVER = "tcp://localhost:61616";
    private static final String UN = "arne";
    private static final String PW = "topsecret";
    private static final String QC2S = "QC2S";
    private static final String QS2C = "QS2C";
    private void run() {
        try {
            // connect
            QueueConnectionFactory qcf = new ActiveMQConnectionFactory(SERVER);
            QueueConnection con = qcf.createQueueConnection(UN, PW);
            con.start();
            QueueSession ses = con.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
            Queue qc2s = ses.createQueue(QC2S);
            Queue qs2c = ses.createQueue(QS2C);
            QueueSender send = ses.createSender(qc2s);
            QueueReceiver recv = ses.createReceiver(qs2c);
            // send
            Message smsg = ses.createTextMessage("Hi from Java!");
            send.send(smsg);
            // receive
            TextMessage rmsg = (TextMessage)recv.receive();
            System.out.println("|" + rmsg.getText() + "|");
            recv.close();
            // disconnect
            send.close();
            ses.close();
            con.close();
        } catch (JMSException e) {
            e.printStackTrace();
        }
    }
    public static void main(String[] args) {
        P1 cli = new P1();
        cli.run();
    }
}
